import { type Static } from '@sinclair/typebox';
import type { ValidationError } from 'ajv';
export declare enum FOTAJobStatus {
    CREATED = "CREATED",
    IN_PROGRESS = "IN_PROGRESS",
    CANCELLED = "CANCELLED",
    DELETION_IN_PROGRESS = "DELETION_IN_PROGRESS",
    COMPLETED = "COMPLETED"
}
export declare const FOTAJobType: import("@sinclair/typebox").TObject<{
    jobId: import("@sinclair/typebox").TString;
    status: import("@sinclair/typebox").TEnum<typeof FOTAJobStatus>;
    statusDetail: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TString>;
    createdAt: import("@sinclair/typebox").TString;
    lastUpdatedAt: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TString>;
    completedAt: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TString>;
}>;
export declare const getFOTAJob: ({ apiKey, endpoint, }: {
    apiKey: string;
    endpoint: URL;
}, fetchImplementation?: typeof fetch) => ({ jobId, }: {
    jobId: string;
}) => Promise<{
    error: Error | ValidationError;
} | {
    result: Static<typeof FOTAJobType>;
}>;
