import { GetItemCommand, PutItemCommand, } from '@aws-sdk/client-dynamodb';
import { cellId } from './cellId.js';
import { marshall, unmarshall } from '@aws-sdk/util-dynamodb';
export const get = ({ db, TableName }) => async (cell) => {
    try {
        const { Item } = await db.send(new GetItemCommand({
            TableName,
            Key: {
                cellId: {
                    S: cellId(cell),
                },
            },
        }));
        const { lat, lng, accuracy } = unmarshall(Item);
        return { lat, lng, accuracy };
    }
    catch {
        return null;
    }
};
export const store = ({ db, TableName }) => async (cell, location) => {
    await db.send(new PutItemCommand({
        TableName,
        Item: marshall({
            cellId: cellId(cell),
            ...location,
            ttl: Math.floor(Date.now() / 1000) + 30 * 24 * 60 * 60,
        }),
    }));
};
